@ECHO OFF

REM ensure we're running elevated
"%systemroot%\system32\cacls.exe" "%systemroot%\system32\config\system" >nul 2>&1
IF ERRORLEVEL 1 GOTO notadmin

IF "%1" == "install" GOTO install
IF "%1" == "remove" GOTO remove
GOTO usage

:install
IF (%2) == () (
 SET aken_path="%~dp0\aken.sys"
) ELSE (
 echo %2
 SET aken_path=%2
)
echo %aken_path%
IF NOT EXIST %aken_path% GOTO notfound
sc create Aken DisplayName= Aken type= kernel start= auto binpath= %aken_path%
REM error= normal is default
IF ERRORLEVEL 1 GOTO failed
sc start Aken
IF ERRORLEVEL 1 GOTO failed
ECHO Success!
GOTO end

:remove
sc stop Aken
sc delete Aken
IF ERRORLEVEL 1 GOTO failed
ECHO Success! (The previous line should read: [SC] DeleteService SUCCESS)
GOTO end

:usage
ECHO Called with parameter: "%1"
ECHO to install the driver, use:
ECHO %0 install [AkenPathname]
ECHO (If no path is given, we will use the directory of this batch file)
ECHO To remove the driver, execute the following:
ECHO %0 remove
PAUSE
GOTO end

:notadmin
ECHO Not running as administrator
GOTO end

:notfound
ECHO Driver not found at specified path (%aken_path%)
GOTO end

:failed
ECHO Something went wrong -- see previous line
GOTO end

:end

pause